<?php
/**
 * installer.php je instalační skript doplňku
 *
 * @package    Albireo I
 * @subpackage update
 * @copyright  Copyright (c) 2009 Martin Novák. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */

class Extension {
	public $page = array ( "title" => "Instalace aktualizace",
						   "text" => "" );

	function __construct () {
		if ( !isset ( $_GET [ "akce" ] ) ) {
			$mysql = $this -> installMySQLFile ();
			if ( !$mysql ) {
				$this -> page [ "text" ] .= '<p><strong class="warning">Došlo k chybě během vytváření tabulky drivefilesv2, kontaktujte podporu Albirea.</strong></p>';
				return false;
			} else {
				$sql = "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ";
				$sql .= $this -> moveDBFiles ( "root", "/" );
				$sql = substr ( $sql, 0, -1 ) .";";
				if ( !Database:: connection () -> query ( $sql ) ) {
					$this -> page [ "text" ] .= '<p><strong class="warning">Selhal převo databázové struktury z drivefiles na drivefilesv2. Kontaktujte podporu Albirea.</strong></p>';
					return false;
				}

				if ( !( Database:: connection () -> query ( "INSERT INTO `header` (`type`,`title`,`author`,`groupid`,`authorizedby`,`publishtime`,`directory`,`anchor`,`file`,`access`,`lang`) VALUES ( 'script', 'Browser', 1, 3, 1, CURRENT_TIMESTAMP(), 3, 'Browser', 'browser', 'wrr', 'cs' );" ) &&
					Database:: connection () -> query ( "INSERT INTO `content` (`id_header`,`editorial`) VALUES ( LAST_INSERT_ID(), 'cor-browser' );" ) &&
					Database:: connection () -> query ( "INSERT INTO `scriptpages` (`id_header`,`script`) VALUES ( LAST_INSERT_ID(), 'cor-browser' );" ) ) ) {
					$this -> page [ "text" ] .= '<p>Nepodařilo se vytvořit procházení obrázků. Kontaktujte podporu Albirea.</p>';
				}
				$instalace = $this -> installFiles ();
				if ( $instalace ) {
					$this -> page [ "text" ] .= '<p>Albireo nyní nahrálo významnou aktualizaci povolující duplicitní názvy souborů v rámci hierarchie fyzických souborů (nikoli v rámci adresáře).</p>';
				}
			}
		}
	}
	
	/**
	* Převede záznamy z tabulky drivefiles do drivefilesv2
	* @return bool
	*/
	private function moveDBFiles ( $physicalname, $url ) {
		if ( strrpos ( $physicalname, "." ) !== false ) {
			return "";
		}
		$sql = "";
		$objects = Database::connection () -> fetchall_assoc ( "SELECT * FROM `drivefiles` WHERE `parent`='$physicalname';" );
		foreach ( $objects as $object ) {
			$sql.= " ('$url','".$object["physicalname"]."','".$object["author"]."','".$object["groupid"]."','".$object["access"]."'),";
			$sql.= $this -> moveDBFiles ( $object["physicalname"], $url.$object["physicalname"]."/" );
		}
		return $sql;
	}

	/**
	* Nahraje do struktury Albirea všechny soubory v temporary/package, kde by se
	* také měly nalézat soubory z Vašeho instalačního balíčku po extrahování ZIPu.
	* @return bool
	*/
	private function installFiles () {

		$PackageManager = new PackageManager ();
		$issue = $PackageManager -> installPackage ();

		if ( $issue [ "errors" ] > 0 ) {
			if ( $issue [ "installed" ] > 0 ) {
				$this -> page [ "text" ] .= '<p><strong class="warning">Podařilo se nainstalovat jen některé soubory rozšíření. Mohlo dojít k poškození integrity systému!</strong></p>';
				$this -> page [ "text" ] .= $issue [ "error messages" ];
				return false;
			} else {
				$this -> page [ "text" ] .= '<p><strong class="warning">Instalace rozšíření selhala při přesunu souborů v rámci struktury Albirea.</strong></p>';
				return false;
			}
	} else {
			$this -> page [ "text" ] .= '<p><strong class="success">Počet instalovaných souborů: '. $issue [ "installed" ] .'</strong></p>';
			$this -> page [ "text" ] .= '<p><a href="#" onclick="$(\'#okmessages\').show(\'slow\');$(this).hide(\'fast\');return false;" title="Ukázat seznam instalovaných souborů">Ukázat seznam instalovaných souborů</a></p>';
			$this -> page [ "text" ] .= '<span id="okmessages" class="undisplayed"><div class="actionbar">';
			$this -> page [ "text" ] .= $issue [ "ok messages" ];
			$this -> page [ "text" ] .= '</div></span>';
		}

		$this -> page [ "text" ] .= '<p><strong class="success">Doplněk Novinky byl úspěšně stažen a nainstalován.</strong></p>';
		return true;
	}

	/**
	 * vrací začátek URL
	* @return string
	*/
	private function getFullPage () {
		$PackageManager -> forbidDestruct ();
		return Tools::getFullPage () .'?continueinstall=true';
	}

	/**
	* instaluje obsah MySQL souboru obsahujícího databázové dotazy. Selže pouze
	* pokud selže databázová funkce Albirea (vrátí false). Pokud jsou některé
	* dotazy špatně, funkce vrátí pouze varování o chybě.
	* @param string $file
	* @return string|bool
	*/
	private function installMySQLFile ( $file = 'mysql.sql' ) {
		if ( file_exists ( "temporary/$file" ) ) {
			$mysql_result = Database::connection () -> sql_from_file ( "temporary/mysql.sql" ); // třída pochází z library/Database.inc.php
			if ( $mysql_result ) {
				if ( $mysql_result [ "errors" ] > 0 ) {
					return '<p><strong class="warning">'. _( "Během provádění SQL příkazů pro MySQL databázi při instalaci rozšíření se vyskytla chyba." ) .'</strong> '. _( "Počet chyb" ) .' <strong>'. $mysql_result [ "errors" ] .'</strong></p>';
				} else {
					return '<p><strong class="success">'. _( "Albireo úspěšně provedlo SQL dotazy na MySQL požadované rozšířením." ) .'</strong></p>';
				}
			} else {
				return false;
			}
		}
	}
}
$extension = new Extension ();
?>